---
title: Firefox 39 for developers
slug: Mozilla/Firefox/Releases/39
tags:
  - Firefox
  - Releases
---
<div>{{FirefoxSidebar}}</div><p>Firefox 39 was released on July 2, 2015. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<p>Highlights:</p>

<ul>
 <li><a href="/en-US/docs/Tools/WebIDE/Setting_up_runtimes#Connecting_over_WiFi">WebIDE now supports debugging Firefox OS devices over Wi-Fi</a></li>
 <li><a href="/en-US/docs/Tools/WebIDE/Working_with_Cordova_apps_in_WebIDE">WebIDE now supports Cordova projects</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector/How_to/Work_with_animations#Firefox_39">Animations view: rewind, fast-forward, and jump to a specific time</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector/How_to/Work_with_animations#Firefox_39">The cubic Bézier curve editor now includes 31 presets</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_HTML#Drag_and_drop">Drag and drop elements in the Page Inspector</a></li>
 <li><a href="/en-US/docs/Tools/Web_Console#Command_history">Web console command history is now persisted across sessions</a></li>
 <li><a href="/en-US/docs/Tools/Web_Console#Helper_commands">$_ console command to print the last result evaluated</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_the_box_model#Firefox_39">Better box model highlighting for inline elements</a></li>
</ul>

<p><a class="external external-icon" href="https://bugzilla.mozilla.org/buglist.cgi?resolution=FIXED&amp;classification=Client%20Software&amp;query_based_on=devtools_resolved_week&amp;chfieldto=2015-03-31&amp;chfield=resolution&amp;query_format=advanced&amp;chfieldfrom=2015-02-22&amp;chfieldvalue=FIXED&amp;bug_status=RESOLVED&amp;bug_status=VERIFIED&amp;bug_status=CLOSED&amp;component=Developer%20Tools&amp;component=Developer%20Tools%3A%203D%20View&amp;component=Developer%20Tools%3A%20Canvas%20Debugger&amp;component=Developer%20Tools%3A%20Console&amp;component=Developer%20Tools%3A%20Debugger&amp;component=Developer%20Tools%3A%20Framework&amp;component=Developer%20Tools%3A%20Graphic%20Commandline%20and%20Toolbar&amp;component=Developer%20Tools%3A%20Inspector&amp;component=Developer%20Tools%3A%20Memory&amp;component=Developer%20Tools%3A%20Netmonitor&amp;component=Developer%20Tools%3A%20Object%20Inspector&amp;component=Developer%20Tools%3A%20Performance%20Tools%20%28Profiler%2FTimeline%29&amp;component=Developer%20Tools%3A%20Responsive%20Mode&amp;component=Developer%20Tools%3A%20Scratchpad&amp;component=Developer%20Tools%3A%20Source%20Editor&amp;component=Developer%20Tools%3A%20Storage%20Inspector&amp;component=Developer%20Tools%3A%20Style%20Editor&amp;component=Developer%20Tools%3A%20User%20Stories&amp;component=Developer%20Tools%3A%20Web%20Audio%20Editor&amp;component=Developer%20Tools%3A%20WebGL%20Shader%20Editor&amp;component=Developer%20Tools%3A%20WebIDE&amp;product=Firefox&amp;known_name=devtools_resolved_week&amp;list_id=12157026">All devtools bugs fixed between Firefox 38 and Firefox 39</a>.</p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Support of the {{cssxref("&lt;string&gt;")}} type on {{cssxref("list-style-type")}}, as well as its shorthand property {{cssxref("list-style")}} has been implemented ({{bug(1144607)}}).</li>
 <li>CSS Scroll Snapping has been implemented ({{bug(945584)}} and {{bug(1138658)}}).</li>
 <li>Cascading of CSS Animations and CSS Transitions has been rewritten to match the latest specification ({{bug(1125455)}}).</li>
 <li>Support for vertical scripts, with the {{cssxref("writing-mode")}} is now turned on by default on Nightly and Developer Edition, but not on Firefox Beta and Firefox Release ({{bug(1099032)}}). Note that implementation is not yet complete and some widgets, like tables, will not obey to all values.</li>
 <li>CSS {{cssxref("filter")}} acts like position: relative + overflow: hidden ({{bug(1125767)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>A new {{glossary("ARIA")}} role, <code>switch</code>, is now supported ({{bug(1136563)}}).</li>
 <li>Support for <code>&lt;link rel="preconnect"&gt;</code> allowing to anticipate a future connection without revealing any information has been implemented ({{bug(1135160)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp"><code>RegExp</code> constructor</a> no longer throws when the first argument is a <code>RegExp</code> and the second <code>flags</code> argument is present ({{bug(1108949)}}).</li>
 <li>The {{jsxref("Object.noSuchMethod", "Object.prototype.__noSuchMethod__")}} property is now deprecated and throws a console warning (see {{bug(1140428)}} and this <a href="https://groups.google.com/forum/#!topic/mozilla.dev.platform/0EkHgphxUo8">platform announcement</a>).</li>
 <li>The implementation of the {{jsxref("Proxy")}} object has been updated to comply more with the ES2015 specification:
  <ul>
   <li>The {{jsxref("Global_Objects/Proxy/handler/defineProperty", "defineProperty")}} and {{jsxref("Global_Objects/Proxy/handler/set", "set")}} handlers now need to explicitly return <code>true</code> to be successful, otherwise a {{jsxref("TypeError")}} exception will be thrown in strict mode ({{bug(1132522)}}).</li>
   <li>If the {{domxref("window")}} object is set as the target, those handlers will now throw a <code>TypeError</code> ({{bug(828137)}}).</li>
  </ul>
 </li>
 <li>When using <a href="/en-US/docs/Web/JavaScript/Reference/Functions/Arrow_functions">arrow functions</a> (<code>=&gt;</code>), a line terminator (<code>\n</code>) is no longer allowed after arrow function arguments (<code>() \n =&gt; {}</code>) ({{bug(1141392)}}).</li>
 <li>{{jsxref("RegExp.prototype.toString")}} is now a generic function ({{bug(1079919)}}).</li>
 <li>The non-standard <code>flags</code> argument of {{jsxref("String.prototype.match()")}}, {{jsxref("String.prototype.search()")}}, and {{jsxref("String.prototype.replace()")}} is now deprecated and throws a console warning ({{bug(1142351)}}).</li>
 <li>The try/catch behavior of {{jsxref("Object.assign()")}} has been removed to conform with the latest ES2015 draft ({{bug(1103344)}}).</li>
</ul>

<h3 id="InterfacesAPIsDOM">Interfaces/APIs/DOM</h3>

<ul>
 <li>The experimental {{domxref("CanvasRenderingContext2D.addHitRegion()")}} method now accepts a <code>path</code> option, which allows you to add <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Hit_regions_and_accessibility#Hit_regions">hit regions</a> to {{domxref("Path2D")}} objects ({{bug(1129147)}}).</li>
 <li>New methods have been added to manipulate {{domxref("FormData")}} objects ({{bug(1085283)}}) and <code>FormData</code> is now supported in Web workers ({{bug(739173)}}).</li>
 <li>The non-standard {{domxref("XMLHttpRequest.sendAsBinary()")}} method has been removed ({{bug(853162)}}).</li>
 <li>Progress in our experimental implementation of Web Animations: {{domxref("AnimationPlayer.startTime")}} is now writeable ({{bug(1073379)}}).</li>
 <li>Progress in our experimental implementation of <a href="/en-US/docs/Web/API/ServiceWorker_API">Service Workers</a>: {{domxref("Cache")}} and {{domxref("CacheStorage")}} interfaces are now implemented ({{bug(940273)}}).</li>
 <li>The experimental <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a> has been activated by default ({{bug(1133861)}}).</li>
 <li>Progress in our experimental implementation of WebGL2: {{domxref("WebGLSync")}} is now implemented ({{bug(1048721)}}).</li>
 <li>Support for {{domxref("MouseEvent.offsetX")}} and {{domxref("MouseEvent.offsetY")}} have been added on desktop ({{bug(69787)}}, but not on Firefox for Android or Firefox OS (they will be added in <a href="/en-US/docs/Mozilla/Firefox/Releases/43">Firefox 43</a>).</li>
</ul>

<h3 id="MathML">MathML</h3>

<p><em>No change.</em></p>

<h3 id="SVG">SVG</h3>

<p><em>No change.</em></p>

<h3 id="AudioVideo">Audio/Video</h3>

<p><em>No change.</em></p>

<h3 id="Miscelleanous">Miscelleanous</h3>

<ul>
 <li><a href="/en-US/docs/Web/Guide/WOFF">WOFF2</a> fonts support is now turned on by default in release version of Firefox (Beta and Release, in addition of Nightly and Developer Edition) ({{bug(1084026)}}).</li>
 <li>The <code><a href="/en-US/docs/Mozilla/Command_Line_Options#-remote_remote_command">-remote</a></code> command-line option has been removed ({{bug(1080319)}}).</li>
 <li>
  <p>Support for new <a href="http://www.bbc.co.uk/newsbeat/article/32220611/diverse-thumbs-up-emojis-with-different-skin-tones-finally-here">Unicode 8.0 skin tone emoji</a> ({{bug(1153460)}}).</p>
 </li>
</ul>

<h2 id="Networking">Networking</h2>

<ul>
 <li>Support for SSLv3 has been completely removed ({{bug(1106470)}}).</li>
</ul>

<h2 id="Security">Security</h2>

<p><em>No change.</em></p>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<p><em>No change.</em></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/39/">Site Compatibility for Firefox 39</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers('38')}}</p>
